﻿// -----------------------------------------------------------------------
// <copyright file="TransitionResultAdapterTest.cs" company="Sławomir Rosiek">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace Rosieks.Web.Flow.Tests
{
    using System.Web.Mvc;
    using System.Web.Routing;
    using Microsoft.VisualStudio.TestTools.UnitTesting;
    using Moq;
    using Rosieks.Web.Flow.Metadata;
    using Rosieks.Web.Flow.Tests.Helpers;

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    [TestClass]
    public class TransitionResultAdapterTest
    {
        [TestMethod]
        public void TransitionWithRoute()
        {
            var httpContext = ContextHelper.CreateHttpContext().WithRequest();
            var routeData = new Rosieks.Web.Flow.RouteData
            {
                RouteName = "haha",
                Url = "haha/{xyz}",
                Values = new RouteValueDictionary(new { xyz = 3 }),
            };
            var state = new Mock<State>().Object;

            // Initialize target
            var adapter = new TransitionResultAdapter();

            // Initialize parameters
            var controllerContext = new ControllerContext();
            controllerContext.HttpContext = httpContext.Object;

            var transition = new Transition("abc", state);
            state.RouteData = routeData;

            // Test
            var result = adapter.CreateResult(transition, controllerContext) as RedirectToRouteResult;
            
            // Verify
            Assert.AreEqual("haha", result.RouteName);
            Assert.AreEqual(1, result.RouteValues.Count);
            Assert.AreEqual(3, result.RouteValues["xyz"]);
        }

        [TestMethod]
        public void TransitionWithUrl()
        {
            var httpContext = ContextHelper.CreateHttpContext().WithRequest();
            var routeData = new Rosieks.Web.Flow.RouteData
            {
                Url = "http://webflow.codeplex.com",
            };
            var state = new Mock<State>().Object;

            // Initialize target
            var adapter = new TransitionResultAdapter();

            // Initialize parameters
            var controllerContext = new ControllerContext();
            controllerContext.HttpContext = httpContext.Object;

            var transition = new Transition("abc", state);
            state.RouteData = routeData;

            // Test
            var result = adapter.CreateResult(transition, controllerContext) as RedirectResult;

            // Verify
            Assert.AreEqual("http://webflow.codeplex.com", result.Url);
        }
    }
}
