﻿
using System.IO;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Rosieks.Web.Flow.Metadata;

namespace Rosieks.Web.Flow.Tests
{
    [TestClass]
    public class WebflowDeserializerTest
    {
        [TestMethod]
        [DeploymentItem(@"Deployment\test1.webflow")]
        public void Test1()
        {
            using (Stream stream = File.OpenRead("test1.webflow"))
            {
                var deserializer = new WebflowDeserializer();

                var model = deserializer.Deserialize(stream);

                var states = model.States.ToArray();

                Assert.AreEqual("Test1", model.Name);
                Assert.AreEqual("Krok1", states[0].Name);
                Assert.AreEqual("Krok2", states[1].Name);
                Assert.AreEqual("Podsumowanie", states[2].Name);

                Assert.AreEqual("Next", states[0].Transitions.ToArray()[0].On);
                Assert.AreEqual(states[1], states[0].Transitions.ToArray()[0].To);

                Assert.AreEqual("Next", states[1].Transitions.ToArray()[0].On);
                Assert.AreEqual(states[2], states[1].Transitions.ToArray()[0].To);
            }
        }
    }
}
