﻿
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Rosieks.Web.Flow.Metadata;
namespace Rosieks.Web.Flow.Tests
{
    [TestClass]
    public class WebflowElementResultProviderTest
    {
        [TestMethod]
        public void ResultProviderByDefaultHasRegisteredTwoAdapters()
        {
            WebflowElementResultProvider.Initialize();

            var viewStateAdapter = WebflowElementResultProvider.Adapters[typeof(ViewState)]();
            var transitionAdapter = WebflowElementResultProvider.Adapters[typeof(Transition)]();

            Assert.IsInstanceOfType(viewStateAdapter, typeof(ViewStateResultAdapter));
            Assert.IsInstanceOfType(transitionAdapter, typeof(TransitionResultAdapter));
        }

        [TestMethod]
        public void Register()
        {
            WebflowElementResultProvider.RegisterAdapter<State, TestResultAdapter>();

            var testAdapter = WebflowElementResultProvider.Adapters[typeof(State)]();

            Assert.IsInstanceOfType(testAdapter, typeof(TestResultAdapter));
        }

        public class TestResultAdapter : IWebflowElementResultAdapter
        {
            public System.Web.Mvc.ActionResult CreateResult(IExecutionObject element, System.Web.Mvc.ControllerContext context)
            {
                throw new System.NotImplementedException();
            }
        }
    }
}
