﻿using System.Web.Mvc;
using System.Web.Routing;
using UseCases.Models;

namespace UseCases
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            //routes.MapRoute(
            //    "Wizard",
            //    "form/{step}",
            //    new { controller = "Home", action = "Flow", flowName = "myFlow" }
            //);

            var flow = new RecruitmentWebflow();

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{flowName}", // URL with parameters
                new { controller = "Home", action = "Index", flowName = UrlParameter.Optional } // Parameter defaults
            );

            //RouteDebug.RouteDebugger.RewriteRoutesForTesting(routes);
        }

        protected void Application_Start()
        {
            ViewEngines.Engines.Clear();
            ViewEngines.Engines.Add(new MyRazorViewEngine());
            AreaRegistration.RegisterAllAreas();

            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
        }

        public class MyRazorViewEngine : RazorViewEngine
        {
            public override ViewEngineResult FindPartialView(ControllerContext controllerContext, string partialViewName, bool useCache)
            {
                return base.FindPartialView(controllerContext, partialViewName, useCache);
            }
        }
    }
}